bookshelf/config/routes.rb
# Copyright 2019 Google LLC.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

Rails.application.routes.draw do

  # Route root of application to BooksController#index action
  root "books#index"

  # Restful routes for BooksController
  resources :books

  get "/logs", to: "stackdriver#logs"
  get "/errors", to: "stackdriver#errors"

end

bookshelf/app/models/book.rb
# Copyright 2019 Google LLC.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

class Book
  # Add Active Model support.
  # Provides constructor that takes a Hash of attribute values.
  include ActiveModel::Model

  # Add Active Model validation support to Book class.
  include ActiveModel::Validations

  validates :title, presence: true

  attr_accessor :id, :title, :author, :published_on, :description, :image_url, :cover_image

  # Return a Google::Cloud::Firestore::Dataset for the configured collection.
  # The collection is used to create, read, update, and delete entity objects.
  def self.collection
    project_id = ENV["GOOGLE_CLOUD_PROJECT"]
    raise "Set the GOOGLE_CLOUD_PROJECT environment variable" if project_id.nil?

    # [START bookshelf_firestore_client]
    require "google/cloud/firestore"
    firestore = Google::Cloud::Firestore.new project_id: project_id
    @collection = firestore.col "books"
    # [END bookshelf_firestore_client]
  end

  def self.storage_bucket
    project_id = ENV["GOOGLE_CLOUD_PROJECT"]
    raise "Set the GOOGLE_CLOUD_PROJECT environment variable" if project_id.nil?

    @storage_bucket = begin
      config = Rails.application.config.x.settings
      # [START bookshelf_cloud_storage_client]
      require "google/cloud/storage"
      bucket_id = project_id + "_bucket"
      storage = Google::Cloud::Storage.new project_id: config["project_id"],
                                           credentials: config["keyfile"]
      bucket = storage.bucket bucket_id
      # [END bookshelf_cloud_storage_client]
      raise "bucket does not exist" if bucket.nil?
      bucket
    end
  end

  # Query Book entities from Cloud Firestore.
  #
  # returns an array of Book query results and the last book title
  # that can be used to query for additional results.
  def self.query options = {}
    query = collection.order :title
    query = query.limit options[:limit] if options[:limit]
    query = query.start_after options[:last_title] if options[:last_title]

    books = []
    begin
      query.get do |book|
        books << Book.from_snapspot(book)
      end
    rescue
    end
    books
  end

  def self.requires_pagination last_title
    if last_title
      collection
        .order(:title)
        .limit(1)
        .start_after(last_title)
        .get.count > 0
    end
  end

  def self.from_snapspot book_snapshot
    book = Book.new
    book.id = book_snapshot.document_id
    book_snapshot.data.each do |name, value|
      book.send "#{name}=", value if book.respond_to? "#{name}="
    end
    book
  end

  # Lookup Book by ID.  Returns Book or nil.
  def self.find id
    # [START bookshelf_firestore_client_get_book]
    book_snapshot = collection.doc(id).get
    Book.from_snapspot book_snapshot if book_snapshot.data
    # [END bookshelf_firestore_client_get_book]
  end

  # Save the book to Firestore.
  # @return true if valid and saved successfully, otherwise false.
  def save
    if valid?
      book_ref = Book.collection.doc id
      book_ref.set \
        title:        title,
        author:       author,
        published_on: published_on,
        description:  description,
        image_url:    image_url
      self.id = book_ref.document_id
      true
    else
      false
    end
  end

  def create
    upload_image if cover_image
    save
  end

  # Set attribute values from provided Hash and save to Firestore.
  def update attributes
    attributes.each do |name, value|
      send "#{name}=", value if respond_to? "#{name}="
    end
    update_image if cover_image
    save
  end

  def update_image
    delete_image if image_url
    upload_image
  end

  def upload_image
    file = Book.storage_bucket.create_file \
      cover_image.tempfile,
      "cover_images/#{id}/#{cover_image.original_filename}",
      content_type: cover_image.content_type,
      acl: "public"
    @image_url = file.public_url
  end

  def destroy
    delete_image if image_url
    book_ref = Book.collection.doc id
    book_ref.delete if book_ref
  end

  def delete_image
    image_uri = URI.parse image_url

    if image_uri.host == "#{Book.storage_bucket.name}.storage.googleapis.com"
      # Remove leading forward slash from image path
      # The result will be the image key, eg. "cover_images/:id/:filename"
      image_path = image_uri.path.sub "/", ""

      file = Book.storage_bucket.file image_path
      file.delete
    end
  end

##################

  def persisted?
    id.present?
  end
end

bookshelf/app/controllers/books_controller.rb
# Copyright 2019 Google LLC.
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#    http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

class BooksController < ApplicationController

  PER_PAGE = 10

  def index
    @books = Book.query limit: PER_PAGE, last_title: params[:last_title]
    @last_title = @books.last&.title
  end

  def new
    @book = Book.new
  end

  def edit
    @book = Book.find params[:id]
  end

  def show
    @book = Book.find params[:id]
  end

  def destroy
    @book = Book.find params[:id]
    @book.destroy
    redirect_to books_path
  end

  def update
    @book = Book.find params[:id]

    if @book.update book_params
      flash[:success] = "Updated Book"
      redirect_to book_path(@book)
    else
      render :edit
    end
  end

  def create
    @book = Book.new book_params

    if @book.create
      flash[:success] = "Added Book"
      redirect_to book_path(@book)
    else
      render :new
    end
  end

  private

  def book_params
    params.require(:book).permit :title, :author, :published_on, :description,
                                 :cover_image
  end

end

bookshelf/app/views/books/_form.html.erb
<%#
  Copyright 2019 Google LLC.
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
%>

<h3>Book</h3>

<% if @book.errors.any? %>
  <div class="errors">
    <% @book.errors.full_messages.each do |message| %>
      <div class="alert alert-danger"><%= message %></div>
    <% end %>
  </div>
<% end %>

<%= form_for @book, :html => { :multipart => true } do |f| %>
  <div class="form-group">
    <%= f.label :title %>
    <%= f.text_field :title %>
  </div>
  <div class="form-group">
    <%= f.label :author %>
    <%= f.text_field :author %>
  </div>
  <div class="form-group">
    <%= f.label :published_on, "Date Published" %>
    <%= f.date_field :published_on %>
  </div>
  <div class="form-group">
    <%= f.label :description %>
    <%= f.text_area :description %>
  </div>
  <div class="form-group">
    <%= f.label :cover_image %>
    <%= f.file_field :cover_image %>
  </div>
  <button class="btn btn-success" type="submit">Save</button>
<% end %>

bookshelf/app/views/books/edit.html.erb
<%#
  Copyright 2019 Google LLC.
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
%>

<%= render partial: "form" %>

bookshelf/app/views/books/index.html.erb
<%#
  Copyright 2019 Google LLC.
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
%>

<h3>Books</h3>

<%= link_to new_book_path, class: "btn btn-success btn-sm" do %>
  <i class="glyphicon glyphicon-plus"></i>
  <span>Add Book</span>
<% end %>

<% @books.each do |book| %>
  <div class="media book">
    <%= link_to book_path(book) do %>
      <div class="media-body">
        <h4><%= book.title %></h4>
        <p><%= book.author %></p>
      </div>
    <% end %>
  </div>
<% end %>

<% if Book.requires_pagination @last_title %>
  <nav>
    <ul class="pager">
      <li><%= link_to "More", books_path(last_title: @last_title) %></li>
    </ul>
  </nav>
<% end %>

<% if @books.none? %>
  <p>No books found.</p>
<% end %>

bookshelf/app/views/books/new.html.erb
<%#
  Copyright 2019 Google LLC.
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
%>

<%= render partial: "form" %>

bookshelf/app/views/books/show.html.erb
<%#
  Copyright 2019 Google LLC.
  Licensed under the Apache License, Version 2.0 (the "License");
  you may not use this file except in compliance with the License.
  You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

  Unless required by applicable law or agreed to in writing, software
  distributed under the License is distributed on an "AS IS" BASIS,
  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  See the License for the specific language governing permissions and
  limitations under the License.
%>

<h3>Book</h3>

<div class="btn-group">
  <%= link_to edit_book_path(@book), class: "btn btn-primary btn-sm" do %>
    <i class="glyphicon glyphicon-edit"></i>
    <span>Edit Book</span>
  <% end %>
  <%= link_to book_path(@book), class: "btn btn-danger btn-sm", method: :delete do %>
    <i class="glyphicon glyphicon-trash"></i>
    <span>Delete Book</span>
  <% end %>
</div>

<div class="media">
  <div class="media-left">
    <img src="<%= @book.image_url %>">
  </div>
  <div class="media-body">
    <h4><%= @book.title %> | &nbsp; <small><%= @book.published_on %></small></h4>
    <h5>By <%= @book.author || "unknown" %></h5>
    <p><%= @book.description %></p>
  </div>
</div>